// Copyright (c) 1993, 1996, 1999 by Sun Microsystems, Inc.

#pragma ident "@(#)userTopLevel.cc	1.48 99/07/29 Sun Microsystems"

#pragma ident	"@(#)userTopLevel.cc	1.48	99/07/29 SMI; TSOL 2.x"


/*******************************************************************************
	userTopLevel.cc

       Associated Header file: userTopLevel.hh
*******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <nl_types.h>
#include <Xm/Xm.h>
#include <Xm/MenuShell.h>
#include "UxXt.h"

#include <Xm/CascadeB.h>
#include <Xm/CascadeBG.h>
#include <Xm/SeparatoG.h>
#include <Xm/PushBG.h>
#include <Xm/RowColumn.h>
#include <Xm/List.h>
#include <Xm/ScrolledW.h>
#include <Xm/Label.h>
#include <Xm/Form.h>
#include <Xm/MainW.h>
#include <X11/Shell.h>
#include "addUserDialog.hh"
#include "modifyUserDialog.hh"
#include "moveUserDialog.hh"
#include "removeUserDialog.hh"
#include "setDefaultsDialog.hh"
#include "setMoveDefaultsDialog.hh"
#include "findUserDialog.hh"
#include "String.h"
#include "AdminContext.hh"
#include "Iterator.h"
#include "UserService.hh"
#include "User.hh"
#include "BaseException.hh"
#include "UIException.hh"
#include "MemoryException.hh"
#include "user_globals.hh"
#include "user_strings.hh"
#include "PolicyService.hh"

#ifdef TSOL
#include "tsolUserInclude.hh"

extern int lchkauth(auth_t, char *);

static user_shell_p create_tsolUserDialog(Widget parent);
user_shell_p tsolUser = NULL;
#endif

#undef	String

/*******************************************************************************
       Includes, Defines, and Global variables from the Declarations Editor:
*******************************************************************************/

Widget 	ModifyUserDialog=NULL;
Widget 	RemoveUserDialog=NULL;


basic_data *	datap = NULL;
int 		Sort = SORT_NAME;
int		HowManyEntries;

/*******************************************************************************
       The following header file defines the context structure.
*******************************************************************************/

#define CONTEXT_MACRO_ACCESS 1
#include "userTopLevel.hh"
#undef CONTEXT_MACRO_ACCESS

Widget	userTopLevel;
Widget	scrolledList1;
Widget	footerLabel;

/* scrolling list entry formats */
char	row_format_str[64];

extern AdminContext	*userContext;
extern int		ShowWhat;
extern medstr		WhoToShow;
extern NameServiceType 	NameService;
extern medstr		Host;
extern medstr		Domain;
extern nl_catd		catd;

extern void set_frames_busy(
		Widget win 
	);
extern void set_frames_unbusy(
		Widget win 
	);
extern 	void dialogCB(
		Widget w, 
		int* answer, 
		XmAnyCallbackStruct* cbs
	);
extern void stringcopy (
		char * dest, 
		char * src, 
		int maxlen
	);
extern void display_errmsg (
                char *  const errmsg,
		Widget parent
	);

extern void helpCB(
		Widget,
		char* helpfile,
		XtPointer
	);
extern char* read_policy_value(
		char * policy
	);


/*******************************************************************************
       The following are Auxiliary functions.
*******************************************************************************/

static int
compare_basic (
	const void *	e1,
	const void *	e2)
{
	return strcmp( ((basic_data *)e1)->uname, ((basic_data *)e2)->uname);
}

static int
compare_comment (
	const void *	e1,
	const void *	e2)
{
	return strcmp( ((basic_data *)e1)->ucomment, 
		((basic_data *)e2)->ucomment);
}

static int
compare_id (
	const void *	e1,
	const void *	e2)
{
	return ( atoi(((basic_data *)e1)->uid) - atoi(((basic_data *)e2)->uid));
}

void
make_edit_sensitive(int flag)
{
	_UxCuserTopLevel *userWin;


	userWin = (_UxCuserTopLevel *) UxGetContext(userTopLevel);

	XtSetSensitive(userWin->Uxmenu2_top_b1, flag);
	XtSetSensitive(userWin->Uxmenu2_top_b2, flag);
}


void
set_copy_sensitive(int flag)
{

	_UxCuserTopLevel	*userWin;

	userWin = (_UxCuserTopLevel *) UxGetContext(userTopLevel);
	XtSetSensitive(userWin->Uxmenu2_p1_b2, flag);
}


void
set_modify_sensitive(int flag)
{

	_UxCuserTopLevel	*userWin;

	userWin = (_UxCuserTopLevel *) UxGetContext(userTopLevel);
	XtSetSensitive(userWin->Uxmenu2_p1_b4, flag);
}


void
set_move_sensitive(int flag)
{

	_UxCuserTopLevel	*userWin;

	userWin = (_UxCuserTopLevel *) UxGetContext(userTopLevel);
	XtSetSensitive(userWin->Uxmenu2_p1_b5, flag);
}

void
set_remove_sensitive(int flag)
{

	_UxCuserTopLevel	*userWin;

	userWin = (_UxCuserTopLevel *) UxGetContext(userTopLevel);
	XtSetSensitive(userWin->Uxmenu2_p1_b3, flag);
}

void
set_find_sensitive(int flag)
{

	_UxCuserTopLevel	*userWin;

	userWin = (_UxCuserTopLevel *) UxGetContext(userTopLevel);
	XtSetSensitive(userWin->Uxmenu2_p2_b1, flag);
}

void
set_sort_sensitive(int flag)
{

	_UxCuserTopLevel	*userWin;

	userWin = (_UxCuserTopLevel *) UxGetContext(userTopLevel);
	XtSetSensitive(userWin->Uxmenu2_p2_b2, flag);
}


void
alloc_data_space(void)
{
	int	num_bytes;

	num_bytes = HowManyEntries * sizeof (basic_data);
	datap = (basic_data *) realloc (datap, num_bytes);

	if (datap == NULL)
	{
    		throw (new MemoryException(catgets(catd, 6, 256, "Memory allocation failure.  Exiting.")));
	}
	return;
}

void
load_info(void)
{

	volatile OrderedCltn	*users=NULL;
	volatile UserService	*user_service=NULL;
	_UxCuserTopLevel	*topLevel;
	XmString		str;
	char			*move_key_value=NULL;
	medstr			footer_message;

	make_edit_sensitive(FALSE);
	HowManyEntries = 0;
	set_frames_busy(userTopLevel);

	topLevel = (_UxCuserTopLevel *) UxGetContext( userTopLevel );

	try {

	if (NameService == name_service_nis_plus) {
		// Turn move OFF.
		set_move_sensitive(FALSE);

		// Set footer msg.
		sprintf (footer_message, RIGHT_FOOTER_MSG_NIS, 
				NAMING_SERVICE_NISPLUS, 
				Domain);
	} else if (NameService == name_service_nis) {
		// Turn move OFF.
		set_move_sensitive(FALSE);

		// Set footer msg.
		sprintf (footer_message, RIGHT_FOOTER_MSG_NIS, 
				NAMING_SERVICE_NIS, 
				Domain);
	} else if (NameService == name_service_etc) {
		// Turn move ON.
		set_move_sensitive(TRUE);

		// Set footer msg.
		sprintf (footer_message, RIGHT_FOOTER_MSG_ETC, 
			Host);
	}

	// Set footer text field.
	str = XmStringCreateLocalized(footer_message);
	XtVaSetValues(footerLabel, 
		XmNlabelString, str,
		NULL);
	XmStringFree(str);

	// Get a User prototype object to check if Move User functionality
	//  should be turned on.
	move_key_value = read_policy_value("USER_KEY_1");
	if (move_key_value != NULL)
		if (!strcmp(move_key_value,"thisis4ironly"))
		{
			XtManageChild(topLevel->Uxmenu2_p1_b5);
			XtManageChild(topLevel->Uxmenu9_p8_b2);
		} else {
			XtUnmanageChild(topLevel->Uxmenu2_p1_b5);
			XtUnmanageChild(topLevel->Uxmenu9_p8_b2);
		}
	else
		XtUnmanageChild(topLevel->Uxmenu2_p1_b5);
#ifdef TSOL
	free(move_key_value);
#endif

	// Create a user service.
	user_service = (volatile UserService *)
		create_user_service(*userContext);

	// Set the filter.
	if (ShowWhat == SHOW_NONE) {
		delete (UserService *)user_service;
	 	HowManyEntries = 0;
		set_frames_unbusy(userTopLevel);
		make_edit_sensitive(TRUE);
		// Pop handler.
	 	return;
	} else if (ShowWhat == SHOW_SOME) {
		((UserService *)user_service)->
			get_filter().remove_all_matchers();
		((UserService *)user_service)->
			get_filter().add_matcher("UNAME", 
			get_login_name_member, WhoToShow);
	} else if (ShowWhat == SHOW_ALL) 
		((UserService *)user_service)->
			get_filter().remove_all_matchers();


	// Get the list of users to display.
	users = (volatile OrderedCltn*) ((UserService *)user_service)->
		read_users();

	HowManyEntries = ((OrderedCltn *)users)->size();
	alloc_data_space();

	// Use an interator to traverse the users.
	Iterator it(*((OrderedCltn *)users));
	int i=0;
	while (it++)
	{
		// Fill the memory table.
		stringcopy (datap[i].uname, 
			(char*)(const char*)(((User*)it())->get_login_name()),
			sizeof(datap[0].uname));
		stringcopy (datap[i].uid,  
			(char*)(const char*)(((User*)it())->get_user_id()), 
			sizeof(datap[0].uid));
		stringcopy (datap[i++].ucomment,
			 (char*)(const char*)(((User*)it())->get_gcos()), 
			sizeof(datap[0].ucomment));
	}

	make_edit_sensitive(TRUE);

	}
    
	catch(BaseException* e) {
			display_errmsg(e->_exceptionMsg, userTopLevel);
	}

	catch(MemoryException* e) {
			display_errmsg(e->_exceptionMsg, userTopLevel);
			exit(-1);
	}
	// Delete the collection.
	delete (OrderedCltn *)users;
	delete (UserService *)user_service;
	set_frames_unbusy(userTopLevel);
}


void
redisplay_info(void)
{
	int		rownum;
	longstr		rowstr;
	XmString	str;

	/* delete all existing rows in the scrolling list */
	XmListDeleteAllItems(scrolledList1);

	set_modify_sensitive(FALSE);
	set_copy_sensitive(FALSE);
	set_remove_sensitive(FALSE);
	set_move_sensitive(FALSE);
	if (HowManyEntries == 0)
	{
		set_sort_sensitive(FALSE);
		set_find_sensitive(FALSE);
		return;
	} else {
		set_sort_sensitive(TRUE);
		set_find_sensitive(TRUE);
	}
	
	if (userContext == NULL)
		return;

	set_frames_busy(userTopLevel);

	/* Sort the data. */
	if (Sort == SORT_NAME)
	{
		qsort (datap, HowManyEntries, sizeof(basic_data), 
			compare_basic);
	} else if (Sort == SORT_ID)
	{
		qsort (datap, HowManyEntries, sizeof(basic_data), 
			compare_id);
	} else if (Sort == SORT_COMMENT)
	{
		qsort (datap, HowManyEntries, sizeof(basic_data), 
			compare_comment);
	}


	// Hide the list while we are changing it to avoid flicker 
	//  and make it go faster. 
	XtUnmanageChild(scrolledList1);


	// Set the list items to the info in the memory array.
	for (	rownum = 0; rownum < HowManyEntries; rownum++)
	{
 	(void)sprintf (rowstr, row_format_str, 
		datap[rownum].uname,
		datap[rownum].uid,
		datap[rownum].ucomment);
#ifdef DEBUG
	(void)printf ("rowstr[%d] is ->%s<-\n", rownum, rowstr);
#endif
	str = XmStringCreateLocalized(rowstr);
	XmListAddItemUnselected(scrolledList1, str, rownum+1);
	XmStringFree(str);
	}

	XtManageChild(scrolledList1);

	set_frames_unbusy(userTopLevel);

}


/*******************************************************************************
       The following are callback functions.
*******************************************************************************/


static	void	loadCB(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
	_UxCuserTopLevel        *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxUserTopLevelContext;
	UxUserTopLevelContext = UxContext =
			(_UxCuserTopLevel *) UxGetContext( UxWidget );
	{
	extern void popupNameService();
	
	popupNameService();
	}
	UxUserTopLevelContext = UxSaveCtx;
}

static	void	exitCB(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
	_UxCuserTopLevel        *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxUserTopLevelContext;
	UxUserTopLevelContext = UxContext =
			(_UxCuserTopLevel *) UxGetContext( UxWidget );
	{
#ifdef TSOL
	tsolUser->clean_up();
#endif
	exit(0);
	}
	UxUserTopLevelContext = UxSaveCtx;
}

static	void	addCB(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
#ifdef TSOL
	wgt = wgt;
	cd = cd;
	cb = cb;

        if (tsolUser == NULL)  
                tsolUser = create_tsolUserDialog(UxTopLevel);
	else
		tsolUser->init();
 
        tsolUser->set_mode(MODE_ADD);
        tsolUser->popup();
#else
	_UxCuserTopLevel        *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxUserTopLevelContext;
	UxUserTopLevelContext = UxContext =
			(_UxCuserTopLevel *) UxGetContext( UxWidget );
	{
	extern Widget create_addUserDialog();
	extern void addUserInit(Widget win);
	extern int Copy_mode;
	_UxCaddUserDialog	*add;
	extern Widget AddUserDialog;
	
	if (AddUserDialog == NULL)
		AddUserDialog = create_addUserDialog();
	else 
	{
		add = (_UxCaddUserDialog *)
				UxGetContext(AddUserDialog);
		if  ( XtIsManaged(add->Uxform3) )
		{
			/* Add User window is already displayed. */
			/* Move it to the front of the window stack. */
			XtPopup(AddUserDialog, XtGrabNone);
		}
	}
	
	XtVaSetValues(UxGetWidget(AddUserDialog), XmNtitle, catgets(catd, 6, 257, "User Manager: Add"), NULL);
	

	/* Initialize with default settings. */
	addUserInit(AddUserDialog);
	Copy_mode = FALSE;  
	
	UxPopupInterface(AddUserDialog, no_grab);
	
	}
	UxUserTopLevelContext = UxSaveCtx;
#endif
}

static	void	modifyCB(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
#ifdef TSOL
	wgt = wgt;
	cd = cd;
	cb = cb;

        if (tsolUser == NULL)
                tsolUser = create_tsolUserDialog(UxTopLevel);
        tsolUser->set_mode(MODE_MODIFY);
        tsolUser->popup();
#else
	_UxCuserTopLevel        *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxUserTopLevelContext;
	UxUserTopLevelContext = UxContext =
			(_UxCuserTopLevel *) UxGetContext( UxWidget );
	{
	extern swidget create_modifyUserDialog3();
	extern void modifyUserInit(Widget win);
	_UxCmodifyUserDialog	*modify;
	
	
	if (ModifyUserDialog == NULL)
		ModifyUserDialog = create_modifyUserDialog3();
	else 
	{
		modify = (_UxCmodifyUserDialog *)
				UxGetContext(ModifyUserDialog);
		if  ( XtIsManaged(modify->Uxform2) )
		{
			/* Modify User window is already displayed. */
			/* Move it to the front of the window stack. */
			XtPopup(ModifyUserDialog, XtGrabNone);
		}
	}	
	/* Initialize the modify dialog. */
	modifyUserInit(ModifyUserDialog);
	
	}
	UxUserTopLevelContext = UxSaveCtx;
#endif /* TSOL */
}

static	void	copyCB(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
#ifdef TSOL
	wgt = wgt;
	cd = cd;
	cb = cb;

        if (tsolUser == NULL)
                tsolUser = create_tsolUserDialog(UxTopLevel);
        tsolUser->set_mode(MODE_COPY);
        tsolUser->popup();
#else
	_UxCuserTopLevel        *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxUserTopLevelContext;
	UxUserTopLevelContext = UxContext =
			(_UxCuserTopLevel *) UxGetContext( UxWidget );
	{
	extern swidget create_addUserDialog();
	extern void copyUserInit(Widget win);
	extern int Copy_reset;
	extern int Copy_mode;
	_UxCaddUserDialog	*add;
	
	extern swidget AddUserDialog;
	
	if (AddUserDialog == NULL)
		AddUserDialog = create_addUserDialog();
	else 
	{
		add = (_UxCaddUserDialog *)
				UxGetContext(AddUserDialog);
		if  ( XtIsManaged(add->Uxform3) )
		{
			/* Add User window is already displayed. */
			/* Move it to the front of the window stack. */
			XtPopup(AddUserDialog, XtGrabNone);
		}
	}
	
	Copy_reset = FALSE;
	Copy_mode = TRUE;
	
	copyUserInit(AddUserDialog);
	
	XtVaSetValues(UxGetWidget(AddUserDialog), XmNtitle, 
		catgets(catd, 6, 258, "User Manager: Copy"), NULL);
	UxPopupInterface(AddUserDialog, no_grab);
	}
	UxUserTopLevelContext = UxSaveCtx;
#endif
}

static	void	setDefaultsCB(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
#ifdef TSOL
	wgt = wgt;
	cd = cd;
	cb = cb;

        if (tsolUser == NULL)
                tsolUser = create_tsolUserDialog(UxTopLevel);
        tsolUser->set_mode(MODE_DEFAULTS);
        tsolUser->popup();
#else
	_UxCuserTopLevel        *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxUserTopLevelContext;
	UxUserTopLevelContext = UxContext =
			(_UxCuserTopLevel *) UxGetContext( UxWidget );
	{
	extern swidget create_setDefaultsDialog();
	extern void setDefaultsInit(Widget win);
	_UxCsetDefaultsDialog	*setDefaults;
	
	extern swidget SetDefaultsDialog;
	
	if (SetDefaultsDialog == NULL)
		SetDefaultsDialog = create_setDefaultsDialog();
	else 
	{
		setDefaults = (_UxCsetDefaultsDialog *)
				UxGetContext(SetDefaultsDialog);
		if  ( XtIsManaged(setDefaults->Uxform3) )
		{
			/* window is already displayed. */
			/* Move it to the front of the window stack. */
			XtPopup(SetDefaultsDialog, XtGrabNone);
		}
	}
	
	setDefaultsInit(SetDefaultsDialog);
	
	UxPopupInterface(SetDefaultsDialog, no_grab);
	}
	UxUserTopLevelContext = UxSaveCtx;
#endif
}

static	void	setMoveDefaultsCB(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
	_UxCuserTopLevel        *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxUserTopLevelContext;
	UxUserTopLevelContext = UxContext =
			(_UxCuserTopLevel *) UxGetContext( UxWidget );
	{
	extern swidget create_setMoveDefaultsDialog();
	extern void setMoveDefaultsInit(Widget win);

	_UxCsetMoveDefaultsDialog	*setMoveDefaults;
	
	extern swidget SetMoveDefaultsDialog;
	
	if (SetMoveDefaultsDialog == NULL)
		SetMoveDefaultsDialog = create_setMoveDefaultsDialog();
	else 
	{
		setMoveDefaults = (_UxCsetMoveDefaultsDialog *)
			UxGetContext(SetMoveDefaultsDialog);
		if  ( XtIsManaged(setMoveDefaults->Uxform3) )
		{
			/* window is already displayed. */
			/* Move it to the front of the window stack. */
			XtPopup(SetMoveDefaultsDialog, XtGrabNone);
		}
	}
	
	setMoveDefaultsInit(SetMoveDefaultsDialog);
	
	UxPopupInterface(SetMoveDefaultsDialog, no_grab);
	}
	UxUserTopLevelContext = UxSaveCtx;
}



static	void	moveCB(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
	_UxCuserTopLevel        *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxUserTopLevelContext;
	UxUserTopLevelContext = UxContext =
			(_UxCuserTopLevel *) UxGetContext( UxWidget );
	{
	extern swidget create_moveUserDialog();
	extern void moveUserInit(Widget win);
	_UxCmoveUserDialog	*move;
	
	extern swidget MoveUserDialog;
	
	if (MoveUserDialog == NULL)
		MoveUserDialog = create_moveUserDialog();
	else 
	{
		move = (_UxCmoveUserDialog *)
				UxGetContext(MoveUserDialog);
		if  ( XtIsManaged(move->UxmoveUserForm) )
		{
			/* Move User window is already displayed. */
			/* Move it to the front of the window stack. */
			XtPopup(MoveUserDialog, XtGrabNone);
		}
	}
	
	moveUserInit(MoveUserDialog);
	
	UxPopupInterface(MoveUserDialog, no_grab);
	}
	UxUserTopLevelContext = UxSaveCtx;
}

static	void	removeCB(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
	_UxCuserTopLevel        *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxUserTopLevelContext;
	UxUserTopLevelContext = UxContext =
			(_UxCuserTopLevel *) UxGetContext( UxWidget );
	{
	extern swidget create_removeUserDialog1();
	extern void removeUserInit(Widget win);
	_UxCremoveUserDialog	*remove;
	
	
	if (RemoveUserDialog == NULL)
		RemoveUserDialog = create_removeUserDialog1();
	else 
	{
		remove = (_UxCremoveUserDialog *)
				UxGetContext(RemoveUserDialog);
		if  ( XtIsManaged(remove->Uxform5) )
		{
			/* Remove User window is already displayed. */
			/* Move it to the front of the window stack. */
			XtPopup(RemoveUserDialog, XtGrabNone);
		}
	}
	
	removeUserInit(RemoveUserDialog);
	
	UxPopupInterface(RemoveUserDialog, no_grab);
	}
	UxUserTopLevelContext = UxSaveCtx;
}

static	void	findCB(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
	_UxCuserTopLevel        *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxUserTopLevelContext;
	UxUserTopLevelContext = UxContext =
			(_UxCuserTopLevel *) UxGetContext( UxWidget );
	{
	extern swidget create_findUserDialog();
	_UxCfindUserDialog	*find;
	static swidget findUserDialog;
	
	if (findUserDialog == NULL)
		findUserDialog = create_findUserDialog();
	else 
	{
		find = (_UxCfindUserDialog *)
				UxGetContext(findUserDialog);
		if  ( XtIsManaged(find->Uxform4) )
		{
			/* Find User window is already displayed. */
			/* Move it to the front of the window stack. */
			XtPopup(findUserDialog, XtGrabNone);
		}
	}	
	
	UxPopupInterface(findUserDialog, no_grab);
	}
	UxUserTopLevelContext = UxSaveCtx;
}

static	void	sortNameCB(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
	_UxCuserTopLevel        *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxUserTopLevelContext;
	UxUserTopLevelContext = UxContext =
			(_UxCuserTopLevel *) UxGetContext( UxWidget );
	{
	Sort = 0;
	redisplay_info();
	}
	UxUserTopLevelContext = UxSaveCtx;
}

static	void	sortIDCB(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
	_UxCuserTopLevel        *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxUserTopLevelContext;
	UxUserTopLevelContext = UxContext =
			(_UxCuserTopLevel *) UxGetContext( UxWidget );
	{
	Sort = 1;
	redisplay_info();
	}
	UxUserTopLevelContext = UxSaveCtx;
}

static	void	sortCommentCB(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
	_UxCuserTopLevel        *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxUserTopLevelContext;
	UxUserTopLevelContext = UxContext =
			(_UxCuserTopLevel *) UxGetContext( UxWidget );
	{
	Sort = 2;
	redisplay_info();
	}
	UxUserTopLevelContext = UxSaveCtx;
}

static	void	redisplayCB(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
	_UxCuserTopLevel        *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxUserTopLevelContext;
	UxUserTopLevelContext = UxContext =
			(_UxCuserTopLevel *) UxGetContext( UxWidget );
	{
	// Load and diaplay the current user data.
	load_info();
	redisplay_info();
	}
	UxUserTopLevelContext = UxSaveCtx;
}

static	void	listSelectCB(
			Widget, 
			XtPointer, 
			XmListCallbackStruct *cbs)
{

	// Don't allow a delete or modify if no items are selected.
	if (cbs->selected_item_count > 0)
	{
#ifdef TSOL
		int sense = lchkauth(TSOL_AUTH_USER_IDENT, "");

		set_modify_sensitive(TRUE);
		set_remove_sensitive(sense);
		set_copy_sensitive(sense);
		set_move_sensitive(TRUE);
#else
		set_modify_sensitive(TRUE);
		set_remove_sensitive(TRUE);
		set_copy_sensitive(TRUE);
		set_move_sensitive(TRUE);
#endif
	} else {
		set_modify_sensitive(FALSE);
		set_remove_sensitive(FALSE);
		set_copy_sensitive(FALSE);
		set_move_sensitive(FALSE);
	}
}

static char*
rstrtok(char* str, char sep)
{
	int len;
	char* pp;

	len = strlen(str);

	if (len < 1)
		return NULL;

	pp = &str[len - 1];

	while ((*pp != sep) && (pp > str))
		pp--;
	if (*pp == sep) {
		*pp = '\0';
		return str;
	}
	else {
		return NULL;
	}
}

/*
 * Helper function for set_column_widths()
 */
static void
set_col_width(
	int*		col_width,
	XmFontList	scrolling_list_fl,
	int		char_width,
	Widget		label)
{
	XmString	xstr;
	Dimension	field_width;
	Dimension	label_width;
	XmFontList	label_fontlist;
	char		buf[256];

	/*
	 *  If a column label is wider than its column,
	 *  make the column wider to match.
	 */

	sprintf(buf, "%*.*s", *col_width, *col_width, "x");
	xstr = XmStringCreateLocalized(buf);
	field_width = XmStringWidth(scrolling_list_fl, xstr);
	XmStringFree(xstr);

	XtVaGetValues(label,
		XmNlabelString, &xstr,
		XmNfontList, &label_fontlist,
		NULL);
	label_width = XmStringWidth(label_fontlist, xstr);

	if (label_width > field_width) {
		*col_width = (int)label_width / char_width;
	}
}

static void
set_column_widths(_UxCuserTopLevel* ctxt)
{
	XmFontList	fl;
	Dimension	chwid;
	XmString	xstr;
	int		username_cw	= 10;
	int		userid_cw	= 10;
	int		usercmnt_cw	= 80;


	XtVaGetValues(scrolledList1,
		XmNfontList, &fl,
		NULL);

	/* Assume scrolling list font is fixed-width */
	xstr = XmStringCreateLocalized("x");
	chwid = XmStringWidth(fl, xstr);
	XmStringFree(xstr);

	/* User */
	set_col_width(&username_cw, fl, chwid, ctxt->UxuserLabel);
	set_col_width(&userid_cw, fl, chwid, ctxt->UxuidLabel);
	set_col_width(&usercmnt_cw, fl, chwid, ctxt->UxcommentLabel);
	sprintf(row_format_str, "%%-%d.%ds    %%%d.%ds    %%-.%ds",
		username_cw, username_cw,
		userid_cw, userid_cw,
		usercmnt_cw);
}

static void
align_list_headers(_UxCuserTopLevel* ctxt)
{
	XmFontList	sl_fontlist;
	Dimension	border, shadow, margin, indent;
	Dimension	col;
	Dimension	wid;
	XmString	xstr;
	int		ii;
	Widget		lab[5];
	char		entry[256];

	set_column_widths(ctxt);

	XtVaGetValues(scrolledList1,
		XmNfontList, &sl_fontlist,
		XmNborderWidth, &border,
		XmNshadowThickness, &shadow,
		XmNlistMarginWidth, &margin,
		NULL);
	indent = border + shadow + margin;

	lab[0] = NULL;
	lab[1] = ctxt->UxuserLabel;
	lab[2] = ctxt->UxuidLabel;
	lab[3] = ctxt->UxcommentLabel;
	sprintf(entry, row_format_str, "x", "x", "x");
	for (ii=3; ii>=1; ii--) {
		if (rstrtok(entry, 'x') != NULL) {
			if (ii == 2) {
				/* right-align uid label */
				strcat(entry, "  ");
				xstr = XmStringCreateLocalized(entry);
				col = XmStringWidth(sl_fontlist, xstr);
				XmStringFree(xstr);
				XtVaGetValues(lab[ii],
					XmNwidth, &wid,
					NULL );
				XtVaSetValues(lab[ii],
					XmNleftOffset, indent + (col - wid),
					XmNalignment, XmALIGNMENT_END,
					NULL );
			}
			else {
				xstr = XmStringCreateLocalized(entry);
				col = XmStringWidth(sl_fontlist, xstr);
				XmStringFree(xstr);
				XtVaSetValues(lab[ii],
					XmNleftOffset, indent + col,
					NULL );
			}
		}
	}

}


/*******************************************************************************
       The 'build_' function creates all the widgets
       using the resource values specified in the Property Editor.
*******************************************************************************/

static Widget	_Uxbuild_userTopLevel()
{
	Widget		menu2_p4_shell;
	Widget		menu2_p1_shell;
	Widget		menu2_p2_shell;
	Widget		menu2_p8_shell;
	Widget		menu2_p5_shell;

	userTopLevel = XtVaCreatePopupShell( "userTopLevel",
			topLevelShellWidgetClass,
			UxTopLevel,
			XmNx, 200,
			XmNy, 200,
			XmNtitle, catgets(catd, 6, 259, "User Manager"),
			XmNminHeight, 140,
			XmNminWidth, 425,
			NULL );
	UxPutContext( userTopLevel, (char *) UxUserTopLevelContext );

	mainWindow1 = XtVaCreateWidget( "mainWindow1",
			xmMainWindowWidgetClass,
			userTopLevel,
			XmNunitType, XmPIXELS,
			XmNscrollBarDisplayPolicy, XmSTATIC,
			XmNvisualPolicy, XmVARIABLE,
			XmNscrollingPolicy, XmAPPLICATION_DEFINED,
			NULL );
	UxPutContext( mainWindow1, (char *) UxUserTopLevelContext );

	form1 = XtVaCreateWidget( "form1",
			xmFormWidgetClass,
			mainWindow1,
			NULL );
	UxPutContext( form1, (char *) UxUserTopLevelContext );

	Widget headerForm = XtVaCreateManagedWidget( "headerForm",
			xmFormWidgetClass,
			form1,
			XmNtopAttachment, XmATTACH_FORM,
			XmNtopOffset, 15,
			XmNleftAttachment, XmATTACH_FORM,
			XmNleftOffset, 10,
			NULL );

	userLabel = XtVaCreateManagedWidget( "userLabel",
			xmLabelWidgetClass,
			headerForm,
			RES_CONVERT( XmNlabelString,
				catgets(catd, 6, 350, "User Name")),
			XmNalignment, XmALIGNMENT_BEGINNING,
			XmNleftAttachment, XmATTACH_FORM,
			NULL );
	UxPutContext( userLabel, (char *) UxUserTopLevelContext );

	uidLabel = XtVaCreateManagedWidget( "uidLabel",
			xmLabelWidgetClass,
			headerForm,
			RES_CONVERT( XmNlabelString,
				catgets(catd, 6, 351, "User ID")),
			XmNalignment, XmALIGNMENT_BEGINNING,
			XmNleftAttachment, XmATTACH_FORM,
			NULL );
	UxPutContext( uidLabel, (char *) UxUserTopLevelContext );

	commentLabel = XtVaCreateManagedWidget( "commentLabel",
			xmLabelWidgetClass,
			headerForm,
			RES_CONVERT( XmNlabelString,
				catgets(catd, 6, 352, "Comment")),
			XmNalignment, XmALIGNMENT_BEGINNING,
			XmNleftAttachment, XmATTACH_FORM,
			NULL );
	UxPutContext( commentLabel, (char *) UxUserTopLevelContext );

	scrolledWindow1 = XtVaCreateManagedWidget( "scrolledWindow1",
			xmScrolledWindowWidgetClass,
			form1,
			XmNscrollingPolicy, XmAPPLICATION_DEFINED,
			XmNwidth, 425,
			XmNheight, 210,
			XmNvisualPolicy, XmVARIABLE,
			XmNscrollBarDisplayPolicy, XmSTATIC,
			XmNshadowThickness, 0,
			XmNbottomAttachment, XmATTACH_FORM,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			XmNtopAttachment, XmATTACH_WIDGET,
			XmNtopWidget, headerForm,
			XmNbottomOffset, 10,
			XmNleftOffset, 10,
			XmNrightOffset, 10,
			NULL );
	UxPutContext( scrolledWindow1, (char *) UxUserTopLevelContext );

	scrolledList1 = XtVaCreateManagedWidget( "scrolledList1",
			xmListWidgetClass,
			scrolledWindow1,
			XmNwidth, 425,
			XmNheight, 210,
			XmNlistSizePolicy, XmCONSTANT,
			NULL );
	UxPutContext( scrolledList1, (char *) UxUserTopLevelContext );

	footerLabel = XtVaCreateManagedWidget( "footerLabel",
			xmLabelWidgetClass,
			mainWindow1,
			RES_CONVERT( XmNlabelString, "      " ),
			XmNalignment, XmALIGNMENT_END,
			XmNmarginRight, 10,
			NULL );
	UxPutContext( footerLabel, (char *) UxUserTopLevelContext );

	menu2 = XtVaCreateManagedWidget( "menu2",
			xmRowColumnWidgetClass,
			mainWindow1,
			XmNrowColumnType, XmMENU_BAR,
			XmNmenuAccelerator, "<KeyUp>F10",
			NULL );
	UxPutContext( menu2, (char *) UxUserTopLevelContext );

	menu2_p4_shell = XtVaCreatePopupShell ("menu2_p4_shell",
			xmMenuShellWidgetClass, menu2,
			XmNwidth, 1,
			XmNheight, 1,
			XmNallowShellResize, TRUE,
			XmNoverrideRedirect, TRUE,
			NULL );

	menu2_p4 = XtVaCreateWidget( "menu2_p4",
			xmRowColumnWidgetClass,
			menu2_p4_shell,
			XmNrowColumnType, XmMENU_PULLDOWN,
			NULL );
	UxPutContext( menu2_p4, (char *) UxUserTopLevelContext );

	menu2_p4_b3 = XtVaCreateManagedWidget( "menu2_p4_b3",
			xmPushButtonGadgetClass,
			menu2_p4,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 261, "Load...") ),
			RES_CONVERT( XmNmnemonic, "L" ),
			NULL );
	UxPutContext( menu2_p4_b3, (char *) UxUserTopLevelContext );

	menu2_p4_b2 = XtVaCreateManagedWidget( "menu2_p4_b2",
			xmSeparatorGadgetClass,
			menu2_p4,
			NULL );
	UxPutContext( menu2_p4_b2, (char *) UxUserTopLevelContext );

	menu2_p4_b1 = XtVaCreateManagedWidget( "menu2_p4_b1",
			xmPushButtonGadgetClass,
			menu2_p4,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 262, "Exit") ),
			RES_CONVERT( XmNmnemonic, "x" ),
			NULL );
	UxPutContext( menu2_p4_b1, (char *) UxUserTopLevelContext );

	menu2_top_b3 = XtVaCreateManagedWidget( "menu2_top_b3",
			xmCascadeButtonWidgetClass,
			menu2,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 263, "File") ),
			RES_CONVERT( XmNmnemonic, "F" ),
			XmNsubMenuId, menu2_p4,
			NULL );
	UxPutContext( menu2_top_b3, (char *) UxUserTopLevelContext );

	menu2_p1_shell = XtVaCreatePopupShell ("menu2_p1_shell",
			xmMenuShellWidgetClass, menu2,
			XmNwidth, 1,
			XmNheight, 1,
			XmNallowShellResize, TRUE,
			XmNoverrideRedirect, TRUE,
			NULL );

	menu2_p1 = XtVaCreateWidget( "menu2_p1",
			xmRowColumnWidgetClass,
			menu2_p1_shell,
			XmNrowColumnType, XmMENU_PULLDOWN,
			NULL );
	UxPutContext( menu2_p1, (char *) UxUserTopLevelContext );

	menu2_p1_b1 = XtVaCreateManagedWidget( "menu2_p1_b1",
			xmPushButtonGadgetClass,
			menu2_p1,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 264, "Add...") ),
			RES_CONVERT( XmNmnemonic, "A" ),
			NULL );
	UxPutContext( menu2_p1_b1, (char *) UxUserTopLevelContext );
#ifdef TSOL
	XtVaSetValues(menu2_p1_b1, XmNsensitive,
	   lchkauth(TSOL_AUTH_USER_IDENT, ""), NULL);
#endif

	menu2_p1_b4 = XtVaCreateManagedWidget( "menu2_p1_b4",
			xmPushButtonGadgetClass,
			menu2_p1,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 265, "Modify...") ),
			RES_CONVERT( XmNmnemonic, "M" ),
			XmNsensitive, FALSE,
			NULL );
	UxPutContext( menu2_p1_b4, (char *) UxUserTopLevelContext );

	menu2_p1_b2 = XtVaCreateManagedWidget( "menu2_p1_b2",
			xmPushButtonGadgetClass,
			menu2_p1,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 266, "Copy...") ),
			RES_CONVERT( XmNmnemonic, "C" ),
			XmNsensitive, FALSE,
			NULL );
	UxPutContext( menu2_p1_b2, (char *) UxUserTopLevelContext );

#ifdef TSOL
	XtVaSetValues(menu2_p1_b2, XmNsensitive,
	   lchkauth(TSOL_AUTH_USER_IDENT, ""), NULL);
#endif

	menu2_p1_b5 = XtVaCreateManagedWidget( "menu2_p1_b5",
			xmPushButtonGadgetClass,
			menu2_p1,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 267, "Move...") ),
			RES_CONVERT( XmNmnemonic, "v" ),
			XmNsensitive, FALSE,
			NULL );
	UxPutContext( menu2_p1_b5, (char *) UxUserTopLevelContext );

	menu9_p8_b1 = XtVaCreateManagedWidget( "menu9_p8_b1",
			xmPushButtonGadgetClass,
			menu2_p1,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 268, "Set Defaults...") ),
			RES_CONVERT( XmNmnemonic, "S" ),
			NULL );
	UxPutContext( menu9_p8_b1, (char *) UxUserTopLevelContext );

	menu9_p8_b2 = XtVaCreateManagedWidget( "menu9_p8_b2",
			xmPushButtonGadgetClass,
			menu2_p1,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 269, "Set Move Defaults...") ),
			RES_CONVERT( XmNmnemonic, "f" ),
			NULL );
	UxPutContext( menu9_p8_b2, (char *) UxUserTopLevelContext );

	XtVaCreateManagedWidget( "",
			xmSeparatorGadgetClass,
			menu2_p1,
			NULL );

	menu2_p1_b3 = XtVaCreateManagedWidget( "menu2_p1_b3",
			xmPushButtonGadgetClass,
			menu2_p1,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 270, "Delete...") ),
			RES_CONVERT( XmNmnemonic, "D" ),
			XmNsensitive, FALSE,
			NULL );
	UxPutContext( menu2_p1_b3, (char *) UxUserTopLevelContext );

#ifdef TSOL
	XtVaSetValues(menu2_p1_b3, XmNsensitive,
	   lchkauth(TSOL_AUTH_USER_IDENT, ""), NULL);
#endif

	menu2_top_b1 = XtVaCreateManagedWidget( "menu2_top_b1",
			xmCascadeButtonWidgetClass,
			menu2,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 271, "Edit") ),
			XmNsubMenuId, menu2_p1,
			RES_CONVERT( XmNmnemonic, "E" ),
			NULL );
	UxPutContext( menu2_top_b1, (char *) UxUserTopLevelContext );

	menu2_p2_shell = XtVaCreatePopupShell ("menu2_p2_shell",
			xmMenuShellWidgetClass, menu2,
			XmNwidth, 1,
			XmNheight, 1,
			XmNallowShellResize, TRUE,
			XmNoverrideRedirect, TRUE,
			NULL );

	menu2_p2 = XtVaCreateWidget( "menu2_p2",
			xmRowColumnWidgetClass,
			menu2_p2_shell,
			XmNrowColumnType, XmMENU_PULLDOWN,
			NULL );
	UxPutContext( menu2_p2, (char *) UxUserTopLevelContext );

	menu2_p2_b1 = XtVaCreateManagedWidget( "menu2_p2_b1",
			xmPushButtonGadgetClass,
			menu2_p2,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 272, "Find...") ),
			RES_CONVERT( XmNmnemonic, "F" ),
			XmNsensitive, FALSE,
			NULL );
	UxPutContext( menu2_p2_b1, (char *) UxUserTopLevelContext );

	menu2_p8_shell = XtVaCreatePopupShell ("menu2_p8_shell",
			xmMenuShellWidgetClass, menu2_p2,
			XmNwidth, 1,
			XmNheight, 1,
			XmNallowShellResize, TRUE,
			XmNoverrideRedirect, TRUE,
			NULL );

	menu2_p8 = XtVaCreateWidget( "menu2_p8",
			xmRowColumnWidgetClass,
			menu2_p8_shell,
			XmNrowColumnType, XmMENU_PULLDOWN,
			NULL );
	UxPutContext( menu2_p8, (char *) UxUserTopLevelContext );

	menu2_p8_b1 = XtVaCreateManagedWidget( "menu2_p8_b1",
			xmPushButtonGadgetClass,
			menu2_p8,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 273, "Name") ),
			RES_CONVERT( XmNmnemonic, "N" ),
			NULL );
	UxPutContext( menu2_p8_b1, (char *) UxUserTopLevelContext );

	menu2_p8_b2 = XtVaCreateManagedWidget( "menu2_p8_b2",
			xmPushButtonGadgetClass,
			menu2_p8,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 274, "ID") ),
			RES_CONVERT( XmNmnemonic, "I" ),
			NULL );
	UxPutContext( menu2_p8_b2, (char *) UxUserTopLevelContext );

	menu2_p8_b3 = XtVaCreateManagedWidget( "menu2_p8_b3",
			xmPushButtonGadgetClass,
			menu2_p8,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 275, "Comment") ),
			RES_CONVERT( XmNmnemonic, "C" ),
			NULL );
	UxPutContext( menu2_p8_b3, (char *) UxUserTopLevelContext );

	menu2_p2_b2 = XtVaCreateManagedWidget( "menu2_p2_b2",
			xmCascadeButtonGadgetClass,
			menu2_p2,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 276, "Sort By") ),
			RES_CONVERT( XmNmnemonic, "S" ),
			XmNsubMenuId, menu2_p8,
			NULL );
	UxPutContext( menu2_p2_b2, (char *) UxUserTopLevelContext );

	menu2_p2_b5 = XtVaCreateManagedWidget( "menu2_p2_b5",
			xmSeparatorGadgetClass,
			menu2_p2,
			NULL );
	UxPutContext( menu2_p2_b5, (char *) UxUserTopLevelContext );

	menu2_p2_b6 = XtVaCreateManagedWidget( "menu2_p2_b6",
			xmPushButtonGadgetClass,
			menu2_p2,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 277, "Rebuild List") ),
			RES_CONVERT( XmNmnemonic, "R" ),
			NULL );
	UxPutContext( menu2_p2_b6, (char *) UxUserTopLevelContext );

	menu2_top_b2 = XtVaCreateManagedWidget( "menu2_top_b2",
			xmCascadeButtonWidgetClass,
			menu2,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 278, "View") ),
			XmNsubMenuId, menu2_p2,
			RES_CONVERT( XmNmnemonic, "V" ),
			NULL );
	UxPutContext( menu2_top_b2, (char *) UxUserTopLevelContext );

	menu2_p5_shell = XtVaCreatePopupShell ("menu2_p5_shell",
			xmMenuShellWidgetClass, menu2,
			XmNwidth, 1,
			XmNheight, 1,
			XmNallowShellResize, TRUE,
			XmNoverrideRedirect, TRUE,
			NULL );

	menu2_p5 = XtVaCreateWidget( "menu2_p5",
			xmRowColumnWidgetClass,
			menu2_p5_shell,
			XmNrowColumnType, XmMENU_PULLDOWN,
			NULL );
	UxPutContext( menu2_p5, (char *) UxUserTopLevelContext );

	menu2_p5_b1 = XtVaCreateManagedWidget( "menu2_p5_b1",
			xmPushButtonGadgetClass,
			menu2_p5,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 279, "About User Manager...") ),
			RES_CONVERT( XmNmnemonic, "A" ),
			NULL );
	UxPutContext( menu2_p5_b1, (char *) UxUserTopLevelContext );

	menu2_p5_b2 = XtVaCreateManagedWidget( "menu2_p5_b2",
			xmPushButtonGadgetClass,
			menu2_p5,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 343, "On Help...") ),
			RES_CONVERT( XmNmnemonic, "O" ),
			NULL );
	UxPutContext( menu2_p5_b2, (char *) UxUserTopLevelContext );

	menu2_top_b4 = XtVaCreateManagedWidget( "menu2_top_b4",
			xmCascadeButtonWidgetClass,
			menu2,
			RES_CONVERT( XmNlabelString, catgets(catd, 6, 280, "Help") ),
			RES_CONVERT( XmNmnemonic, "H" ),
			XmNsubMenuId, menu2_p5,
			NULL );
	UxPutContext( menu2_top_b4, (char *) UxUserTopLevelContext );

	XtAddCallback( scrolledList1, XmNdefaultActionCallback,
		(XtCallbackProc) modifyCB,
		(XtPointer) UxUserTopLevelContext );

	XtAddCallback( scrolledList1, XmNbrowseSelectionCallback,
		(XtCallbackProc) listSelectCB,
		(XtPointer) UxUserTopLevelContext );

	XtVaSetValues(menu2,
			XmNmenuHelpWidget, menu2_top_b4,
			NULL );

	XtAddCallback( menu2_p4_b3, XmNactivateCallback,
		(XtCallbackProc) loadCB,
		(XtPointer) UxUserTopLevelContext );

	XtAddCallback( menu2_p4_b1, XmNactivateCallback,
		(XtCallbackProc) exitCB,
		(XtPointer) UxUserTopLevelContext );

	XtAddCallback( menu2_p1_b1, XmNactivateCallback,
		(XtCallbackProc) addCB,
		(XtPointer) UxUserTopLevelContext );

	XtAddCallback( menu2_p1_b4, XmNactivateCallback,
		(XtCallbackProc) modifyCB,
		(XtPointer) UxUserTopLevelContext );

	XtAddCallback( menu2_p1_b2, XmNactivateCallback,
		(XtCallbackProc) copyCB,
		(XtPointer) UxUserTopLevelContext );

	XtAddCallback( menu2_p1_b5, XmNactivateCallback,
		(XtCallbackProc) moveCB,
		(XtPointer) UxUserTopLevelContext );

	XtAddCallback( menu9_p8_b1, XmNactivateCallback,
		(XtCallbackProc) setDefaultsCB,
		(XtPointer) UxUserTopLevelContext );

	XtAddCallback( menu9_p8_b2, XmNactivateCallback,
		(XtCallbackProc) setMoveDefaultsCB,
		(XtPointer) UxUserTopLevelContext );

	XtAddCallback( menu2_p1_b3, XmNactivateCallback,
		(XtCallbackProc) removeCB,
		(XtPointer) UxUserTopLevelContext );

	XtAddCallback( menu2_p2_b1, XmNactivateCallback,
		(XtCallbackProc) findCB,
		(XtPointer) UxUserTopLevelContext );

	XtAddCallback( menu2_p8_b1, XmNactivateCallback,
		(XtCallbackProc) sortNameCB,
		(XtPointer) UxUserTopLevelContext );

	XtAddCallback( menu2_p8_b2, XmNactivateCallback,
		(XtCallbackProc) sortIDCB,
		(XtPointer) UxUserTopLevelContext );

	XtAddCallback( menu2_p8_b3, XmNactivateCallback,
		(XtCallbackProc) sortCommentCB,
		(XtPointer) UxUserTopLevelContext );

	XtAddCallback( menu2_p2_b6, XmNactivateCallback,
		(XtCallbackProc) redisplayCB,
		(XtPointer) UxUserTopLevelContext );

	XtAddCallback( menu2_p5_b1, XmNactivateCallback,
		(XtCallbackProc) helpCB,
		"user.t.hlp" );

	XtAddCallback( menu2_p5_b2, XmNactivateCallback,
		(XtCallbackProc) helpCB,
		"athelp.t.hlp" );


	XtAddCallback( userTopLevel, XmNdestroyCallback,
		(XtCallbackProc) exitCB,
		(XtPointer) UxUserTopLevelContext);

	XmMainWindowSetAreas( mainWindow1, menu2, (Widget) NULL,
			(Widget) NULL, (Widget) NULL, form1 );
	XtVaSetValues( mainWindow1, XmNmessageWindow, footerLabel, NULL );

	align_list_headers(UxUserTopLevelContext);

	XtManageChild(form1);
	XtManageChild(mainWindow1);

	return ( userTopLevel );
}

/*******************************************************************************
       The following is the 'Interface function' which is the
       external entry point for creating this interface.
       This function should be called from your application or from
       a callback function.
*******************************************************************************/

Widget	create_userTopLevel()
{
	Widget                  rtrn;
	_UxCuserTopLevel        *UxContext;
	static int		_Uxinit = 0;

	UxUserTopLevelContext = UxContext =
		(_UxCuserTopLevel *) UxNewContext( sizeof(_UxCuserTopLevel), False );


	if ( ! _Uxinit )
	{
		UxLoadResources( "userTopLevel.rf" );
		_Uxinit = 1;
	}

	rtrn = _Uxbuild_userTopLevel();

	return(rtrn);
}

#ifdef TSOL
static user_shell_p
create_tsolUserDialog(Widget parent)
{
	user_shell_p new_dialog = new user_shell_c;

	new_dialog->create(parent, NULL);
	new_dialog->init();
	return (new_dialog);
}
#endif 

/*******************************************************************************
       END OF FILE
*******************************************************************************/
